------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008 Vadim Godunko <vgodunko@gmail.com>                      --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Completers;
with Qt4.Menus;
with Qt4.Validators;
with Qt_Ada.Internals.Object_Registry;
with Qt_Ada.Internals.Objects;
with Qt_Ada.Internals.Objects.Object_Utilities;

with Qt_Ada.Internals.Objects.Line_Edit_Proxies;
pragma Warnings (Off, Qt_Ada.Internals.Objects.Line_Edit_Proxies);
--  Elaboration of the proxy tagged type package register proxy object
--  constructor. Bindings must be able to create proxy object of the
--  corresponding tagged type for works properly.

package body Qt4.Line_Edits is

   procedure backspace_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, backspace_0_wrapper,
                     "__Qt4Ada_QLineEdit_backspace_0_wrapper");

   function createStandardContextMenu_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, createStandardContextMenu_0_wrapper,
                     "__Qt4Ada_QLineEdit_createStandardContextMenu_0_wrapper");

   function completer_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, completer_0_wrapper,
                     "__Qt4Ada_QLineEdit_completer_0_wrapper");

   function cursorPosition_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, cursorPosition_0_wrapper,
                     "__Qt4Ada_QLineEdit_cursorPosition_0_wrapper");

   function cursorPositionAt_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : not null access constant Qt4.Points.Internals.QPoint)
       return Qt4.Q_Integer;
   pragma Import (C, cursorPositionAt_0_wrapper,
                     "__Qt4Ada_QLineEdit_cursorPositionAt_0_wrapper");

   procedure cursorBackward_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mark : Qt4.bool;
     Steps : Qt4.Q_Integer);
   pragma Import (C, cursorBackward_0_wrapper,
                     "__Qt4Ada_QLineEdit_cursorBackward_0_wrapper");

   procedure cursorForward_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mark : Qt4.bool;
     Steps : Qt4.Q_Integer);
   pragma Import (C, cursorForward_0_wrapper,
                     "__Qt4Ada_QLineEdit_cursorForward_0_wrapper");

   procedure cursorWordBackward_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mark : Qt4.bool);
   pragma Import (C, cursorWordBackward_0_wrapper,
                     "__Qt4Ada_QLineEdit_cursorWordBackward_0_wrapper");

   procedure cursorWordForward_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mark : Qt4.bool);
   pragma Import (C, cursorWordForward_0_wrapper,
                     "__Qt4Ada_QLineEdit_cursorWordForward_0_wrapper");

   procedure del_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, del_0_wrapper,
                     "__Qt4Ada_QLineEdit_del_0_wrapper");

   procedure deselect_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, deselect_0_wrapper,
                     "__Qt4Ada_QLineEdit_deselect_0_wrapper");

   procedure displayText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, displayText_0_wrapper,
                     "__Qt4Ada_QLineEdit_displayText_0_wrapper");

   function dragEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, dragEnabled_0_wrapper,
                     "__Qt4Ada_QLineEdit_dragEnabled_0_wrapper");

   function echoMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Line_Edits.Line_Edit_Echo_Mode;
   pragma Import (C, echoMode_0_wrapper,
                     "__Qt4Ada_QLineEdit_echoMode_0_wrapper");

   procedure end_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mark : Qt4.bool);
   pragma Import (C, end_0_wrapper,
                     "__Qt4Ada_QLineEdit_end_0_wrapper");

   function hasAcceptableInput_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, hasAcceptableInput_0_wrapper,
                     "__Qt4Ada_QLineEdit_hasAcceptableInput_0_wrapper");

   function hasFrame_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, hasFrame_0_wrapper,
                     "__Qt4Ada_QLineEdit_hasFrame_0_wrapper");

   function hasSelectedText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, hasSelectedText_0_wrapper,
                     "__Qt4Ada_QLineEdit_hasSelectedText_0_wrapper");

   procedure home_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mark : Qt4.bool);
   pragma Import (C, home_0_wrapper,
                     "__Qt4Ada_QLineEdit_home_0_wrapper");

   procedure inputMask_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, inputMask_0_wrapper,
                     "__Qt4Ada_QLineEdit_inputMask_0_wrapper");

   procedure insert_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     New_Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, insert_0_wrapper,
                     "__Qt4Ada_QLineEdit_insert_0_wrapper");

   function isModified_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isModified_0_wrapper,
                     "__Qt4Ada_QLineEdit_isModified_0_wrapper");

   function isReadOnly_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isReadOnly_0_wrapper,
                     "__Qt4Ada_QLineEdit_isReadOnly_0_wrapper");

   function isRedoAvailable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isRedoAvailable_0_wrapper,
                     "__Qt4Ada_QLineEdit_isRedoAvailable_0_wrapper");

   function isUndoAvailable_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.bool;
   pragma Import (C, isUndoAvailable_0_wrapper,
                     "__Qt4Ada_QLineEdit_isUndoAvailable_0_wrapper");

   function maxLength_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, maxLength_0_wrapper,
                     "__Qt4Ada_QLineEdit_maxLength_0_wrapper");

   procedure selectedText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, selectedText_0_wrapper,
                     "__Qt4Ada_QLineEdit_selectedText_0_wrapper");

   function selectionStart_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return Qt4.Q_Integer;
   pragma Import (C, selectionStart_0_wrapper,
                     "__Qt4Ada_QLineEdit_selectionStart_0_wrapper");

   procedure setCompleter_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     C : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setCompleter_0_wrapper,
                     "__Qt4Ada_QLineEdit_setCompleter_0_wrapper");

   procedure setCursorPosition_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Pos : Qt4.Q_Integer);
   pragma Import (C, setCursorPosition_0_wrapper,
                     "__Qt4Ada_QLineEdit_setCursorPosition_0_wrapper");

   procedure setDragEnabled_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, setDragEnabled_0_wrapper,
                     "__Qt4Ada_QLineEdit_setDragEnabled_0_wrapper");

   procedure setEchoMode_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Mode : Qt4.Line_Edits.Line_Edit_Echo_Mode);
   pragma Import (C, setEchoMode_0_wrapper,
                     "__Qt4Ada_QLineEdit_setEchoMode_0_wrapper");

   procedure setFrame_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, setFrame_0_wrapper,
                     "__Qt4Ada_QLineEdit_setFrame_0_wrapper");

   procedure setInputMask_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Input_Mask : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setInputMask_0_wrapper,
                     "__Qt4Ada_QLineEdit_setInputMask_0_wrapper");

   procedure setMaxLength_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Length : Qt4.Q_Integer);
   pragma Import (C, setMaxLength_0_wrapper,
                     "__Qt4Ada_QLineEdit_setMaxLength_0_wrapper");

   procedure setModified_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, setModified_0_wrapper,
                     "__Qt4Ada_QLineEdit_setModified_0_wrapper");

   procedure setReadOnly_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     B : Qt4.bool);
   pragma Import (C, setReadOnly_0_wrapper,
                     "__Qt4Ada_QLineEdit_setReadOnly_0_wrapper");

   procedure setSelection_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Start : Qt4.Q_Integer;
     Length : Qt4.Q_Integer);
   pragma Import (C, setSelection_0_wrapper,
                     "__Qt4Ada_QLineEdit_setSelection_0_wrapper");

   procedure setValidator_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     V : access constant Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, setValidator_0_wrapper,
                     "__Qt4Ada_QLineEdit_setValidator_0_wrapper");

   procedure text_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Returns : not null access Qt4.Strings.Internals.QString);
   pragma Import (C, text_0_wrapper,
                     "__Qt4Ada_QLineEdit_text_0_wrapper");

   function validator_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject)
       return not null access Qt_Ada.Internals.Objects.QObject;
   pragma Import (C, validator_0_wrapper,
                     "__Qt4Ada_QLineEdit_validator_0_wrapper");

   procedure clear_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, clear_0_wrapper,
                     "__Qt4Ada_QLineEdit_clear_0_wrapper");

   procedure copy_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, copy_0_wrapper,
                     "__Qt4Ada_QLineEdit_copy_0_wrapper");

   procedure cut_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, cut_0_wrapper,
                     "__Qt4Ada_QLineEdit_cut_0_wrapper");

   procedure paste_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, paste_0_wrapper,
                     "__Qt4Ada_QLineEdit_paste_0_wrapper");

   procedure redo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, redo_0_wrapper,
                     "__Qt4Ada_QLineEdit_redo_0_wrapper");

   procedure selectAll_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, selectAll_0_wrapper,
                     "__Qt4Ada_QLineEdit_selectAll_0_wrapper");

   procedure setText_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Text : not null access constant Qt4.Strings.Internals.QString);
   pragma Import (C, setText_0_wrapper,
                     "__Qt4Ada_QLineEdit_setText_0_wrapper");

   procedure undo_0_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject);
   pragma Import (C, undo_0_wrapper,
                     "__Qt4Ada_QLineEdit_undo_0_wrapper");

   procedure setAlignment_wrapper
    (Self : not null access Qt_Ada.Internals.Objects.QObject;
     Flag : Qt4.Alignment);
   pragma Import
    (C, setAlignment_wrapper, "__Qt4Ada_QLineEdit_setAlignment_wrapper");

   -------------------
   -- Set_Alignment --
   -------------------

   procedure Set_Alignment
    (Self : not null access Q_Line_Edit'Class;
     Flag : Qt4.Alignment)
   is
   begin
      setAlignment_wrapper (Self.QObject_View, Flag);
   end Set_Alignment;

   pragma Style_Checks ("N");

   ---------------
   -- Backspace --
   ---------------

   procedure Backspace
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      backspace_0_wrapper
       (Self.QObject_View);
   end Backspace;

   ----------------------------------
   -- Create_Standard_Context_Menu --
   ----------------------------------

   function Create_Standard_Context_Menu
    (Self : not null access Q_Line_Edit'Class)
       return not null access Qt4.Menus.Q_Menu'Class
   is
   begin
      return
        Qt4.Menus.Q_Menu'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (createStandardContextMenu_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Create_Standard_Context_Menu;

   ---------------
   -- Completer --
   ---------------

   function Completer
    (Self : not null access constant Q_Line_Edit'Class)
       return not null access Qt4.Completers.Q_Completer'Class
   is
   begin
      return
        Qt4.Completers.Q_Completer'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (completer_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Completer;

   ---------------------
   -- Cursor_Position --
   ---------------------

   function Cursor_Position
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        cursorPosition_0_wrapper
         (Self.QObject_View);
   end Cursor_Position;

   ------------------------
   -- Cursor_Position_At --
   ------------------------

   function Cursor_Position_At
    (Self : not null access Q_Line_Edit'Class;
     Pos : Qt4.Points.Q_Point)
       return Qt4.Q_Integer
   is
   begin
      return
        cursorPositionAt_0_wrapper
         (Self.QObject_View,
          Qt4.Points.Internals.QPoint_View (Pos));
   end Cursor_Position_At;

   ---------------------
   -- Cursor_Backward --
   ---------------------

   procedure Cursor_Backward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean;
     Steps : Qt4.Q_Integer
       :=  1)
   is
   begin
      cursorBackward_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Mark),
        Steps);
   end Cursor_Backward;

   --------------------
   -- Cursor_Forward --
   --------------------

   procedure Cursor_Forward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean;
     Steps : Qt4.Q_Integer
       :=  1)
   is
   begin
      cursorForward_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Mark),
        Steps);
   end Cursor_Forward;

   --------------------------
   -- Cursor_Word_Backward --
   --------------------------

   procedure Cursor_Word_Backward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean)
   is
   begin
      cursorWordBackward_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Mark));
   end Cursor_Word_Backward;

   -------------------------
   -- Cursor_Word_Forward --
   -------------------------

   procedure Cursor_Word_Forward
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean)
   is
   begin
      cursorWordForward_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Mark));
   end Cursor_Word_Forward;

   ---------
   -- Del --
   ---------

   procedure Del
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      del_0_wrapper
       (Self.QObject_View);
   end Del;

   --------------
   -- Deselect --
   --------------

   procedure Deselect
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      deselect_0_wrapper
       (Self.QObject_View);
   end Deselect;

   ------------------
   -- Display_Text --
   ------------------

   function Display_Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      displayText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Display_Text;

   ------------------
   -- Drag_Enabled --
   ------------------

   function Drag_Enabled
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (dragEnabled_0_wrapper
           (Self.QObject_View));
   end Drag_Enabled;

   ---------------
   -- Echo_Mode --
   ---------------

   function Echo_Mode
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Line_Edits.Line_Edit_Echo_Mode
   is
   begin
      return
        echoMode_0_wrapper
         (Self.QObject_View);
   end Echo_Mode;

   --------------
   -- Line_End --
   --------------

   procedure Line_End
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean)
   is
   begin
      end_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Mark));
   end Line_End;

   --------------------------
   -- Has_Acceptable_Input --
   --------------------------

   function Has_Acceptable_Input
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasAcceptableInput_0_wrapper
           (Self.QObject_View));
   end Has_Acceptable_Input;

   ---------------
   -- Has_Frame --
   ---------------

   function Has_Frame
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasFrame_0_wrapper
           (Self.QObject_View));
   end Has_Frame;

   -----------------------
   -- Has_Selected_Text --
   -----------------------

   function Has_Selected_Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (hasSelectedText_0_wrapper
           (Self.QObject_View));
   end Has_Selected_Text;

   ----------
   -- Home --
   ----------

   procedure Home
    (Self : not null access Q_Line_Edit'Class;
     Mark : Standard.Boolean)
   is
   begin
      home_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (Mark));
   end Home;

   ----------------
   -- Input_Mask --
   ----------------

   function Input_Mask
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      inputMask_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Input_Mask;

   ------------
   -- Insert --
   ------------

   procedure Insert
    (Self : not null access Q_Line_Edit'Class;
     New_Text : Qt4.Strings.Q_String)
   is
   begin
      insert_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (New_Text));
   end Insert;

   -----------------
   -- Is_Modified --
   -----------------

   function Is_Modified
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isModified_0_wrapper
           (Self.QObject_View));
   end Is_Modified;

   ------------------
   -- Is_Read_Only --
   ------------------

   function Is_Read_Only
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isReadOnly_0_wrapper
           (Self.QObject_View));
   end Is_Read_Only;

   -----------------------
   -- Is_Redo_Available --
   -----------------------

   function Is_Redo_Available
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isRedoAvailable_0_wrapper
           (Self.QObject_View));
   end Is_Redo_Available;

   -----------------------
   -- Is_Undo_Available --
   -----------------------

   function Is_Undo_Available
    (Self : not null access constant Q_Line_Edit'Class)
       return Standard.Boolean
   is
   begin
      return
        Qt4.To_Boolean
         (isUndoAvailable_0_wrapper
           (Self.QObject_View));
   end Is_Undo_Available;

   ----------------
   -- Max_Length --
   ----------------

   function Max_Length
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        maxLength_0_wrapper
         (Self.QObject_View);
   end Max_Length;

   -------------------
   -- Selected_Text --
   -------------------

   function Selected_Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      selectedText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Selected_Text;

   ---------------------
   -- Selection_Start --
   ---------------------

   function Selection_Start
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Q_Integer
   is
   begin
      return
        selectionStart_0_wrapper
         (Self.QObject_View);
   end Selection_Start;

   -------------------
   -- Set_Completer --
   -------------------

   procedure Set_Completer
    (Self : not null access Q_Line_Edit'Class;
     C : not null access Qt4.Completers.Q_Completer'Class)
   is
   begin
      setCompleter_0_wrapper
       (Self.QObject_View,
        C.QObject_View);
   end Set_Completer;

   -------------------------
   -- Set_Cursor_Position --
   -------------------------

   procedure Set_Cursor_Position
    (Self : not null access Q_Line_Edit'Class;
     Pos : Qt4.Q_Integer)
   is
   begin
      setCursorPosition_0_wrapper
       (Self.QObject_View,
        Pos);
   end Set_Cursor_Position;

   ----------------------
   -- Set_Drag_Enabled --
   ----------------------

   procedure Set_Drag_Enabled
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean)
   is
   begin
      setDragEnabled_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (B));
   end Set_Drag_Enabled;

   -------------------
   -- Set_Echo_Mode --
   -------------------

   procedure Set_Echo_Mode
    (Self : not null access Q_Line_Edit'Class;
     Mode : Qt4.Line_Edits.Line_Edit_Echo_Mode)
   is
   begin
      setEchoMode_0_wrapper
       (Self.QObject_View,
        Mode);
   end Set_Echo_Mode;

   ---------------
   -- Set_Frame --
   ---------------

   procedure Set_Frame
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean)
   is
   begin
      setFrame_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (B));
   end Set_Frame;

   --------------------
   -- Set_Input_Mask --
   --------------------

   procedure Set_Input_Mask
    (Self : not null access Q_Line_Edit'Class;
     Input_Mask : Qt4.Strings.Q_String)
   is
   begin
      setInputMask_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Input_Mask));
   end Set_Input_Mask;

   --------------------
   -- Set_Max_Length --
   --------------------

   procedure Set_Max_Length
    (Self : not null access Q_Line_Edit'Class;
     Length : Qt4.Q_Integer)
   is
   begin
      setMaxLength_0_wrapper
       (Self.QObject_View,
        Length);
   end Set_Max_Length;

   ------------------
   -- Set_Modified --
   ------------------

   procedure Set_Modified
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean)
   is
   begin
      setModified_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (B));
   end Set_Modified;

   -------------------
   -- Set_Read_Only --
   -------------------

   procedure Set_Read_Only
    (Self : not null access Q_Line_Edit'Class;
     B : Standard.Boolean)
   is
   begin
      setReadOnly_0_wrapper
       (Self.QObject_View,
        Qt4.To_bool (B));
   end Set_Read_Only;

   -------------------
   -- Set_Selection --
   -------------------

   procedure Set_Selection
    (Self : not null access Q_Line_Edit'Class;
     Start : Qt4.Q_Integer;
     Length : Qt4.Q_Integer)
   is
   begin
      setSelection_0_wrapper
       (Self.QObject_View,
        Start,
        Length);
   end Set_Selection;

   -------------------
   -- Set_Validator --
   -------------------

   procedure Set_Validator
    (Self : not null access Q_Line_Edit'Class;
     V : access constant Qt4.Validators.Q_Validator'Class)
   is
   begin
      setValidator_0_wrapper
       (Self.QObject_View,
        Qt_Ada.Internals.Objects.Object_Utilities.Corresponding_QObject (V));
   end Set_Validator;

   ----------
   -- Text --
   ----------

   function Text
    (Self : not null access constant Q_Line_Edit'Class)
       return Qt4.Strings.Q_String
   is
      Returns : Qt4.Strings.Q_String;

   begin
      text_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Returns));

      return Returns;
   end Text;

   ---------------
   -- Validator --
   ---------------

   function Validator
    (Self : not null access constant Q_Line_Edit'Class)
       return not null access Qt4.Validators.Q_Validator'Class
   is
   begin
      return
        Qt4.Validators.Q_Validator'Class
         (Qt_Ada.Internals.Object_Registry.To_Q_Object
           (validator_0_wrapper
             (Self.QObject_View)).all)'Access;
   end Validator;

   -----------
   -- Clear --
   -----------

   procedure Clear
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      clear_0_wrapper
       (Self.QObject_View);
   end Clear;

   ----------
   -- Copy --
   ----------

   procedure Copy
    (Self : not null access constant Q_Line_Edit'Class)
   is
   begin
      copy_0_wrapper
       (Self.QObject_View);
   end Copy;

   ---------
   -- Cut --
   ---------

   procedure Cut
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      cut_0_wrapper
       (Self.QObject_View);
   end Cut;

   -----------
   -- Paste --
   -----------

   procedure Paste
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      paste_0_wrapper
       (Self.QObject_View);
   end Paste;

   ----------
   -- Redo --
   ----------

   procedure Redo
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      redo_0_wrapper
       (Self.QObject_View);
   end Redo;

   ----------------
   -- Select_All --
   ----------------

   procedure Select_All
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      selectAll_0_wrapper
       (Self.QObject_View);
   end Select_All;

   --------------
   -- Set_Text --
   --------------

   procedure Set_Text
    (Self : not null access Q_Line_Edit'Class;
     Text : Qt4.Strings.Q_String)
   is
   begin
      setText_0_wrapper
       (Self.QObject_View,
        Qt4.Strings.Internals.QString_View (Text));
   end Set_Text;

   ----------
   -- Undo --
   ----------

   procedure Undo
    (Self : not null access Q_Line_Edit'Class)
   is
   begin
      undo_0_wrapper
       (Self.QObject_View);
   end Undo;

end Qt4.Line_Edits;
